#!/bin/awk -f

BEGIN {
  if ((ARGC < 3) || (ARGC > 4)) {
    printf "Usage: MicroDVDSplit.awk <time> <input> [output]\n" \
      >> "/dev/stderr";
    printf " time: time in frames\n" >> "/dev/stderr";
    exit(-1);
  }

  output1 = (ARGC == 4) ? ARGV[3] ".1" : ARGV[2] ".1";
  output2 = (ARGC == 4) ? ARGV[3] ".2" : ARGV[2] ".2";
  printf "" > output1;
  printf "" > output2;

  time = ARGV[1];

  ARGV[3] = ARGV[1] = "";
}

# For dos and mac
{
  sub(/\r/, "", $0);
  sub(/\f/, "", $0);
}

{
  gsub(/[\{\}]/, " ", $0);

  beg = $1;
  end = $2;
  $1 = $2 = "";

  sub(/^ +/, "", $0);

  if (time > end) {
    printf "{%d}{%d}%s\n", beg, end, $0 >> output1;
  } else if (time < beg) {
    printf "{%d}{%d}%s\n", beg - time, end - time, $0 >> output2;
  } else {
    printf "{%d}{%d}%s\n", beg, time, $0 >> output1;
    printf "{%d}{%d}%s\n", 0, end - time, $0 >> output2;
  }
}
