#!/bin/awk -f

BEGIN {
  if ((ARGC < 3) || (ARGC > 4)) {
    printf "Usage: MicroDVDSpread.awk <fact> <input> [output]\n" \
      >> "/dev/stderr";
    printf " fact: factor close to 1\n" >> "/dev/stderr";
    exit(-1);
  }

  output = (ARGC == 4) ? ARGV[3] : "";
  if (output != "") printf "" > output;

  fact = ARGV[1];

  ARGV[3] = ARGV[1] = "";
}

# For dos and mac
{
  sub(/\r/, "", $0);
  sub(/\f/, "", $0);
}

{
  gsub(/[\{\}]/, " ", $0);
  beg = int($1 * fact);
  end = int($2 * fact);
  $1 = $2 = "";

  sub(/^ +/, "", $0);

  if (output == "") {
    printf "{%d}{%d}%s\n", beg, end, $0;
  } else {
    printf "{%d}{%d}%s\n", beg, end, $0 >> output;
  }
}
